/**
   build with:

  g++ -Wall -g -O0 -I../build/src/ES -I../interface -o infoActivity infoActivity.cpp -L../../stage/usr/lib64 -lglite_ce_es_client -lgridsite -lgsoap++ -lglite_security_gsoap_plugin_2713_cxx
  
*/
#include "glite/ce/es-client-api-c/CallFactory.h"
#include "glite/ce/es-client-api-c/ComputingActivity.h"
#include "glite/ce/es-client-api-c/InternalBaseFault.h"
#include "glite/ce/es-client-api-c/typedefs.h"

#include <string>
#include <vector>
#include <iostream>

using namespace std;
using namespace emi_es::client::wrapper;
using namespace emi_es::client::comm;

//Namespace namespaces[] = {};

SOAP_NMAC struct Namespace namespaces[] = {};

void soap_serialize_xsd__QName(soap*, std::basic_string<char, std::char_traits<char>, std::allocator<char> > const*) {}

int main( int argc, char* argv[] ) {
  
  if ( argc < 3 )
    return 0;
  
  string endpoint = argv[1];
  
  vector<string> ids, attrs;
  for( int j = 2; j<argc; ++j ) {
    ids.push_back( argv[j] );
  }
  
  AbstractCall *call = CallFactory::makeCall( endpoint, ids, attrs );
  string error;
  uid_t userID = ::getuid( );
  
  string usercert = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  string userkey  = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  if ( !::getenv("NOAUTH") ) {
    if(!call->init( usercert, userkey, error ))
      {
	cerr << error << endl;
	return 1;
      }
  } else {
    if(!call->init("", "", error ))
      {
	cerr << error << endl;
	return 1;
      }
  }
  
  emi_es::client::comm::AbstractCall::SOAP_CALL_ERROR_CODES code;
  if(!call->execute( error, code ) ) {
    cerr << error << endl;
//    cerr << AbstractCall::SOAP_CALL_ERROR_CODES_STRING[code] << endl;
    return 1;
  }
  
  map<string, ComputingActivity> success;
  map<string, InternalBaseFault> faults;
  call->getResponse( success, faults );
  
  {
    map<string, ComputingActivity>::const_iterator it = success.begin();
    for( ; it != success.end( ); ++it )
      {
	cout << "\n**** ActivityID = " << it->first << endl;
	cout << it->second.toString() << endl;
      }
  }
  
  {
    map<string, InternalBaseFault>::const_iterator it = faults.begin();
    for( ; it != faults.end( ); ++it )
      {
	cout << "\n**** ActivityID = " << it->first << endl;
	cout << it->second.toString() <<endl;
      }
  }
  
  delete call;
  
  return 0;
}
