/**
   build with:

  g++ -Wall -g -O0 -I../build/src/ES -I../interface -o listActivity listActivity.cpp -L../../stage/usr/lib64 -lglite_ce_es_client -lgridsite -lgsoap++ -lglite_security_gsoap_plugin_2713_cxx
  
*/
#include "glite/ce/es-client-api-c/ListActivityCall.h"
#include "glite/ce/es-client-api-c/ListActivities.h"
#include "glite/ce/es-client-api-c/util.h"
#include "glite/ce/es-client-api-c/CallFactory.h"
#include <string>
#include <vector>
#include <iostream>

using namespace std;
using namespace emi_es::client::wrapper;
using namespace emi_es::client::comm;
using namespace emi_es::client::util;

SOAP_NMAC struct Namespace namespaces[] = {};

void soap_serialize_xsd__QName(soap*, std::basic_string<char, std::char_traits<char>, std::allocator<char> > const*) {}

//------------------------------------------------------------------------------
int main( int argc, char* argv[] ) {
  if ( argc < 2 )
    return 0;
  
  string endpoint = argv[1];

  vector<ActivityStatus::ACTIVITYSTATUS> states;
  states.push_back( (ActivityStatus::ACTIVITYSTATUS)GetRandom::get_random(7) );
  states.push_back( (ActivityStatus::ACTIVITYSTATUS)GetRandom::get_random(7) );
  states.push_back( (ActivityStatus::ACTIVITYSTATUS)GetRandom::get_random(7) );
  vector<ActivityStatus::ACTIVITYSTATUSATTRS> statesattrs;
  statesattrs.push_back( (ActivityStatus::ACTIVITYSTATUSATTRS)GetRandom::get_random(18) );
  statesattrs.push_back( (ActivityStatus::ACTIVITYSTATUSATTRS)GetRandom::get_random(18) );
  statesattrs.push_back( (ActivityStatus::ACTIVITYSTATUSATTRS)GetRandom::get_random(18) );
  
  
  ListActivities list( time(0)-10, time(0) + 1000, 10, states, statesattrs );
  
  AbstractCall* call = CallFactory::makeCall( endpoint, &list );
  string error;
  
  uid_t userID = ::getuid( );
  
  string usercert = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  string userkey  = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  
  if ( !::getenv("NOAUTH") ) {
    if(!call->init( usercert, userkey, error ))
      {
	cerr << error << endl;
	return 1;
      }
  } else {
    if(!call->init("", "", error ))
      {
	cerr << error << endl;
	return 1;
      }
  }
  
  emi_es::client::comm::AbstractCall::SOAP_CALL_ERROR_CODES code;
  if(!call->execute( error, code ) ) {
    cerr << error << endl;
//    cerr << AbstractCall::SOAP_CALL_ERROR_CODES_STRING[code] << endl;
    return 1;
  }
  
  vector<string> IDS;
  bool trunc;
  call->getResponse( trunc, IDS );
  
  vector<string>::const_iterator it = IDS.begin();
  for( ; it != IDS.end( ); ++it )
    cout << "JobID=[" << *it << "]" << endl;
  
  delete call;

  return 0;
}

































//------------------------------------------------------------------------------
// vector<string> getAnnotation()
// {
//   vector<string> tmp;
//   tmp.push_back("Annotation 1");
//   tmp.push_back("Annotation 2");
//   tmp.push_back("Annotation 3");
//   tmp.push_back("Annotation 4");
//   return tmp;
// }

// //------------------------------------------------------------------------------
// vector<Environment> getEnvironment( )
// {
//   vector<Environment> envVec;
//   Environment env1, env2, env3;

//   env1.Name  = "X509";
//   env1.Value = "/tmp/x509_cert";
//   env2.Name  = "HOME";
//   env2.Value = "/home/dorigoa";
//   env3.Name  = "EDITOR";
//   env3.Value = "/bin/vi";

//   envVec.push_back( env1 );
//   envVec.push_back( env2 );
//   envVec.push_back( env3 );

//   return envVec;
// }

// //------------------------------------------------------------------------------
// vector<RemoteLogging> getRemoteLogging()
// {
//   RemoteLogging R1("EMIES", "http://cream-52.pd.infn.it:8443/emi-es/services/EMIES", false );
//   RemoteLogging R2("EMIES", "http://cream-05.pd.infn.it:8443/emi-es/services/EMIES", false );
//   vector<RemoteLogging> rlVec;
//   rlVec.push_back( R1 );
//   rlVec.push_back( R2 );
//   return rlVec;
// }

// //------------------------------------------------------------------------------
// ExecutableType getExecutable()
// {
//   vector<string> exeargs1;//, exeargs2;
//   exeargs1.push_back("-l");
//   exeargs1.push_back("-t");
//   exeargs1.push_back("-S");
  
//   //exeargs2.push_back("-h");
//   //exeargs2.push_back("-l");

  
//   ExecutableType exe1( "/bin/ls", exeargs1, 0 );
//   //ExecutableType exe2( "/bin/df", exeargs2, "yes" );
  
//   vector<ExecutableType> exeVec;
//   //  exeVec.push_back( exe1 );
//   //exeVec.push_back( exe2 );
//   return exe1;//exeVec;
// }

// //------------------------------------------------------------------------------
// vector<ExecutableType> getPreExecutables()
// {
//   vector<ExecutableType> preexe;
  
//   vector<string> preexeargs;
//   preexeargs.push_back( "GLITE_USER_HOME" );
//   preexeargs.push_back( "/opt/glite" );
//   ExecutableType preexe1( "setenv", preexeargs, 0 );
//   preexe.push_back( preexe1 );
//   return preexe;
// }

// //------------------------------------------------------------------------------
// vector<ExecutableType> getPostExecutables()
// {
//   vector<ExecutableType> postexe;

//   vector<string> postexeargs;
//   postexeargs.push_back( "GLITE_USER_HOME" );
//   ExecutableType postexe1( "unsetenv", postexeargs, 0 );
//   postexe.push_back( postexe1 );
//   return postexe;
// }

// //------------------------------------------------------------------------------
// OptionalTime getExpirationTime( )
// {
//   OptionalTime exp;
//   exp.__item = time(0) + 86400;
//   exp.optional = false;
//   return exp;
// }

// //------------------------------------------------------------------------------
// OptionalTime getWipeTime( )
// {
//   OptionalTime wipe;
//   wipe.__item = time(0) + 3*86400;
//   wipe.optional = false;
//   return wipe;
// }

// //------------------------------------------------------------------------------
// Notification getNotification( )
// {
//   //vector<Notification> tmp;
//   vector<string> recipients;
//   recipients.push_back("alvise72@gmail.com");
//   recipients.push_back("alvise.dorigo@pd.infn.it");

//   vector<int> onstate;
//   onstate.push_back(ES_USCORETYPES__PrimaryActivityStatus__PREPROCESSING);
//   onstate.push_back(ES_USCORETYPES__PrimaryActivityStatus__PROCESSING_ACCEPTING);
//   onstate.push_back(ES_USCORETYPES__PrimaryActivityStatus__PROCESSING_RUNNING);

//   Notification N1( ES_USCOREADL__ProtocolTypeEnumeration__email, 
// 		   recipients, 
// 		   onstate, 
// 		   false );

//   //  tmp.push_back( N1 );
//   return N1;//tmp;
// }

// //------------------------------------------------------------------------------
// vector<RuntimeEnvironment> getRuntimeEnvironments( )
// {
//   RuntimeEnvironment RE("CMSGRID", "v1.3", vector<string>(), false );
  
//   vector<RuntimeEnvironment> reVec;
//   reVec.push_back( RE );

//   return reVec;
// }

// //------------------------------------------------------------------------------
// vector<OperatingSystem> getOperatingSystems( )
// {
//   OperatingSystem os1( "WindowsXP", "Win32", "5.0" );
//   OperatingSystem os2( "MaxOSX", "Unix", "10.6.8" );
//   OperatingSystem os3( "Linux", "Unix", "SL5_64" );
  
//   vector<OperatingSystem> osVec;
//   osVec.push_back( os1 );
//   osVec.push_back( os2 );
//   osVec.push_back( os3 );

//   return osVec;
// }

// //------------------------------------------------------------------------------
// vector<Source> getSources( )
// {
//   Source s1("gsiftp://lxgrid05.pd.infn.it//home/dorigoa/ISB1", 
// 	    "delegid1", 
// 	    getOptions( ) );

//   Source s2("gsiftp://lxgrid05.pd.infn.it//home/dorigoa/ISB2", 
// 	    "delegid2", 
// 	    getOptions( ) );

//   vector<Source> vecS;

//   vecS.push_back( s1 );
//   vecS.push_back( s2 );
//   return vecS;
// }

// //------------------------------------------------------------------------------
// vector<Target> getTargets( )
// {
//   Target t1( "ftp://mac-grid-01/Users/dorigoa/ISB1", 
// 	     "delegid3", 
// 	     getOptions( ), 
// 	     true, 
// 	     ES_USCOREADL__CreationFlagEnumeration__overwrite, 
// 	     false, 
// 	     false, 
// 	     false);

//   Target t2( "ftp://mac-grid-01/Users/dorigoa/ISB2", 
// 	     "delegid3", 
// 	     getOptions( ), 
// 	     true, 
// 	     ES_USCOREADL__CreationFlagEnumeration__overwrite, 
// 	     false, 
// 	     false, 
// 	     false);

//   Target t3( "ftp://mac-grid-01/Users/dorigoa/ISB3", 
// 	     "delegid3", 
// 	     getOptions( ), 
// 	     true, 
// 	     ES_USCOREADL__CreationFlagEnumeration__overwrite, 
// 	     false, 
// 	     false, 
// 	     false);

//   vector<Target> vecT;
//   vecT.push_back( t1 );
//   vecT.push_back( t2 );
//   vecT.push_back( t3 );

//   return vecT;
// }

// //------------------------------------------------------------------------------
// vector<OptionType> getOptions( )
// {
//   OptionType opt1;
//   OptionType opt2;
//   opt1.Name = "Option1";
//   opt1.Value = "Value1";
//   opt2.Name = "Option2";
//   opt2.Value = "Value2";
//   vector<OptionType> oVec;
//   oVec.push_back( opt1 );
//   oVec.push_back( opt2 );

//   return oVec;
// }
