/**
   build with:

  g++ -Wall -g -O0 -I../build/src/ES -I../interface -o notifyService notifyService.cpp -L../../stage/usr/lib64 -lglite_ce_es_client -lgridsite -lgsoap++ -lglite_security_gsoap_plugin_2713_cxx
  
*/

#include "glite/ce/es-client-api-c/InternalBaseFault.h"
#include "glite/ce/es-client-api-c/CallFactory.h"
#include "glite/ce/es-client-api-c/util.h"

#include <string>
#include <vector>
#include <utility>
#include <iostream>

using namespace std;
using namespace emi_es::client::wrapper;
using namespace emi_es::client::util;
using namespace emi_es::client::comm;

SOAP_NMAC struct Namespace namespaces[] = {};

void soap_serialize_xsd__QName(soap*, 
			       std::basic_string<char, std::char_traits<char>, 
			       std::allocator<char> > const*) {}

int main ( int argc, char* argv[] ) {
  if ( argc < 2 )
    return 0;
  
  string endpoint = argv[1];

  

  
  vector<pair<string, AbstractCall::NOTIFYMESSAGE> > items;
  for( int j = 2; j<argc; ++j ) {
    items.push_back( make_pair( argv[j], (AbstractCall::NOTIFYMESSAGE)(NotifyMessageType)GetRandom::get_random(1) ));
  }

      
  AbstractCall *call = CallFactory::makeCall( endpoint, items );
  string error;
  uid_t userID = ::getuid( );
  
  string usercert = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  string userkey  = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID ); 
  if ( !::getenv("NOAUTH") ) {
    if(!call->init( usercert, userkey, error ))
      {
	cerr << error << endl;
	return 1;
      }
  } else {
    if(!call->init("", "", error ))
      {
	cerr << error << endl;
	return 1;
      }
  }
  
  emi_es::client::comm::AbstractCall::SOAP_CALL_ERROR_CODES code;
  if(!call->execute( error, code ) ) {
    cerr << error << endl;
//    cerr << AbstractCall::SOAP_CALL_ERROR_CODES_STRING[code] << endl;
    return 1;
  }

  vector<pair<string, InternalBaseFault> > resp;
  call->getResponse( resp );

  delete call;
  
}
