/**
   build with:

  g++ -Wall -g -O0 -I../build/src/ES -I../interface -o resumeActivity resumeActivity.cpp -L../../stage/usr/lib64 -lglite_ce_es_client -lgridsite -lgsoap++ -lglite_security_gsoap_plugin_2713_cxx
  
*/
#include "glite/ce/es-client-api-c/InternalBaseFault.h"
#include "glite/ce/es-client-api-c/CallFactory.h"

#include <string>
#include <vector>
#include <iostream>

using namespace std;
using namespace emi_es::client::comm;
using namespace emi_es::client::wrapper;
using namespace emi_es::client::util;

SOAP_NMAC struct Namespace namespaces[] = {};

void soap_serialize_xsd__QName(soap*, std::basic_string<char, std::char_traits<char>, std::allocator<char> > const*) {}

int main ( int argc, char* argv[] ) {
  if ( argc < 2 )
    return 0;
  
  string endpoint = argv[1];

  vector<string> toResume;
  for( int j = 2; j<argc; ++j ) {
    //toPause.ES_USCORETYPES__ActivityID.push_back( argv[j] );
    toResume.push_back( argv[j] );
  }

  AbstractCall* call = CallFactory::makeCall( endpoint, toResume, AbstractCall::RESUME );

  string error;
  uid_t userID = ::getuid( );
  
  string usercert = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  string userkey  = string("/tmp/x509up_u") + boost::lexical_cast<string>( userID );
  if ( !::getenv("NOAUTH") ) {
    if(!call->init( usercert, userkey, error ))
      {
	cerr << error << endl;
	return 1;
      }
  } else {
    if(!call->init("", "", error ))
      {
	cerr << error << endl;
	return 1;
      }
  }
  
  emi_es::client::comm::AbstractCall::SOAP_CALL_ERROR_CODES code;
  if(!call->execute( error, code ) ) {
    cerr << error << endl;
//    cerr << AbstractCall::SOAP_CALL_ERROR_CODES_STRING[code] << endl;
    return 1;
  }
  
  map<string, ULONG64> successful;
  map<string, InternalBaseFault> failed;
    
  call->getResponse( successful, failed );
    
  {
    map<string, ULONG64>::const_iterator it;
    for( it = successful.begin( ); it != successful.end( ); ++it )
      {
	cout << it->first << "  -->  ";
	cout << it->second << endl;
      }
  }
  
  {
    map<string, InternalBaseFault>::const_iterator it;
    for( it = failed.begin( ); it != failed.end( ); ++it )
      {
	cout << it->first << "  -->  Fault:";
	cout << it->second.toString( ) << endl << endl;
      }
  }
  
  delete call;
  
}
