/**
   build with:

  g++ -Wall -g -O0 -I/usr/include/libxml2 -I../build/src/ES -I../interface -o testXml testXml.cpp -L../../stage/usr/lib64 -lglite_ce_es_client -lgridsite -lgsoap++ -lglite_security_gsoap_plugin_2713_cxx
  
*/

#include <iostream>

#include "glite/ce/es-client-api-c/CreateActivityDescriptionFromXML.h"
#include "glite/ce/es-client-api-c/DeserializeActivityIdentification.h"
#include "glite/ce/es-client-api-c/DeserializeApplicationEnvironment.h"
#include "glite/ce/es-client-api-c/DeserializeApplicationExecutable.h"
#include "glite/ce/es-client-api-c/DeserializeApplicationPrePostExecutable.h"

#include "glite/ce/es-client-api-c/ActivityDescription.h"
#include "glite/ce/es-client-api-c/DeserializeApplicationExpirationTime.h"
#include "glite/ce/es-client-api-c/DeserializeApplicationWipeTime.h"
#include "glite/ce/es-client-api-c/ExecutableType.h"
#include "glite/ce/es-client-api-c/ActivityIdentification.h"
#include "glite/ce/es-client-api-c/ParallelEnvironment.h"

#include "glite/ce/es-client-api-c/DeserializeInputFile.h"
#include "glite/ce/es-client-api-c/DeserializeInputFileSource.h"

#include "glite/ce/es-client-api-c/DeserializeOutputFile.h"
//#include "glite/ce/es-client-api-c/DeserializeResourcesOperatingSystem.h"
//#include "glite/ce/es-client-api-c/DeserializeResourcesRuntimeEnvironment.h"
#include "glite/ce/es-client-api-c/DeserializeResourcesParallelEnvironment.h"
#include "glite/ce/es-client-api-c/DeserializeResourcesSlotRequirement.h"
#include "glite/ce/es-client-api-c/DeserializeOutputFileTarget.h"
#include "glite/ce/es-client-api-c/DeserializeResources.h"


#include "glite/ce/es-client-api-c/XMLDoc.h"
#include "glite/ce/es-client-api-c/typedefs.h"
#include "glite/ce/es-client-api-c/util.h"

#include "glite/ce/es-client-api-c/ES_CLIENT.nsmap"

SOAP_NMAC struct Namespace namespaces[] = {};

using namespace std;
using namespace emi_es::client;

struct soap;

void soap_serialize_xsd__QName(soap*, std::basic_string<char, std::char_traits<char>, std::allocator<char> > const*) {}

int main( int argc, char* argv[] )
{
  if( argc<2 ) return 1;

  while( 1 ) {
    xml::XMLDoc doc( argv[1] );
    if( !doc.is_valid( ) ) {
      cerr << doc.error( ) << endl;
      return 1;
    }
    
    emi_es::client::wrapper::Resources* R = emi_es::client::xml::DeserializeResources::get( &doc, 1 );
    delete R;
  }
  return 0;
}
