Summary: C/C++ libraries for the client of the CREAM service
Name: glite-ce-cream-client-api-c
Version: %{extversion}
Release: %{extage}.%{extdist}
License: Apache Software License
Vendor: EMI
URL: http://glite.cern.ch/
Group: System Environment/Libraries
BuildArch: %{_arch}
BuildRequires: chrpath, libtool
BuildRequires: %{!?extbuilddir: glite-ce-wsdl, glite-build-common-cpp, } gsoap-devel
BuildRequires: %{!?extbuilddir: gridsite-devel,} libxml2-devel, boost-devel
BuildRequires: %{!?extbuilddir: voms-devel,} classads-devel
BuildRequires: %{!?extbuilddir: glite-lbjp-common-gsoap-plugin-devel,} log4cpp-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
AutoReqProv: yes
Source: %{name}-%{version}-%{release}.tar.gz

%global debug_package %{nil}

%description
The package contains C/C++ libraries for the client of the CREAM service

%prep
 

%setup -c -q

%build
%{!?extbuilddir:%define extbuilddir "--"}
if test "x%{extbuilddir}" == "x--" ; then
  ./configure --prefix=%{buildroot}/usr --disable-static PVER=%{version}
  make
fi

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}
%{!?extbuilddir:%define extbuilddir "--"}
if test "x%{extbuilddir}" == "x--" ; then
  make install
else
  cp -R %{extbuilddir}/* %{buildroot}
fi
sed 's|^prefix=.*|prefix=/usr|g' %{buildroot}%{_libdir}/pkgconfig/cream-client-api-c.pc > %{buildroot}%{_libdir}/pkgconfig/cream-client-api-c.pc.new
mv %{buildroot}%{_libdir}/pkgconfig/cream-client-api-c.pc.new %{buildroot}%{_libdir}/pkgconfig/cream-client-api-c.pc
sed 's|^prefix=.*|prefix=/usr|g' %{buildroot}%{_libdir}/pkgconfig/cream-client-api-soap.pc > %{buildroot}%{_libdir}/pkgconfig/cream-client-api-soap.pc.new
mv %{buildroot}%{_libdir}/pkgconfig/cream-client-api-soap.pc.new %{buildroot}%{_libdir}/pkgconfig/cream-client-api-soap.pc
sed 's|^prefix=.*|prefix=/usr|g' %{buildroot}%{_libdir}/pkgconfig/cream-client-api-util.pc > %{buildroot}%{_libdir}/pkgconfig/cream-client-api-util.pc.new
mv %{buildroot}%{_libdir}/pkgconfig/cream-client-api-util.pc.new %{buildroot}%{_libdir}/pkgconfig/cream-client-api-util.pc
sed 's|^prefix=.*|prefix=/usr|g' %{buildroot}%{_libdir}/pkgconfig/es-client-api-c.pc > %{buildroot}%{_libdir}/pkgconfig/es-client-api-c.pc.new
mv %{buildroot}%{_libdir}/pkgconfig/es-client-api-c.pc.new %{buildroot}%{_libdir}/pkgconfig/es-client-api-c.pc
rm %{buildroot}%{_libdir}/*.la
chrpath --delete %{buildroot}%{_libdir}/libglite_ce_cream_client_util.so.0.0.0
chrpath --delete %{buildroot}%{_libdir}/libglite_ce_cream_client_soap.so.0.0.0

%clean
rm -rf %{buildroot}
 
%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root)
%dir /usr/share/doc/%{name}-%{version}/
%doc /usr/share/doc/%{name}-%{version}/LICENSE
%{_libdir}/libglite_ce_cream_client_*.so.0
%{_libdir}/libglite_ce_cream_client_*.so.0.0.0
%{_libdir}/libglite_ce_es_client.so.0
%{_libdir}/libglite_ce_es_client.so.0.0.0



%package -n glite-ce-cream-client-devel
Summary: Development files for the client of the CREAM service
Group: System Environment/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: glite-jobid-api-cpp-devel, glite-jobid-api-c-devel,
Requires: glite-lbjp-common-gsoap-plugin-devel
Requires: boost-devel, classads-devel, log4cpp-devel, gsoap-devel
Requires: voms-devel, gridsite-devel, libxml2-devel, glite-build-common-cpp

%description -n glite-ce-cream-client-devel
The package contains development files for the client of the CREAM service

%files -n glite-ce-cream-client-devel
%defattr(-,root,root)
%dir /usr/include/glite/
%dir /usr/include/glite/ce/
%dir /usr/include/glite/ce/cream-client-api-c/
/usr/include/glite/ce/cream-client-api-c/*.h
/usr/include/glite/ce/cream-client-api-c/*.nsmap
%dir /usr/include/glite/ce/es-client-api-c
/usr/include/glite/ce/es-client-api-c/*.h
/usr/include/glite/ce/es-client-api-c/*.nsmap
%{_libdir}/pkgconfig/*.pc
%{_libdir}/libglite_ce_cream_client_*.so
%{_libdir}/libglite_ce_es_client.so




%changelog
* %{extcdate} CREAM group <cream-support@lists.infn.it> - %{extversion}-%{extage}.%{extdist}
- %{extclog}

